#include <vector>
#include <thread>
#include <cassert>
#include <poppler.h>
#include <cairo.h>

int main()
{
	std::vector<std::thread> threads;
	for(int t = 0; t < std::thread::hardware_concurrency() / 2; t++)
		threads.emplace_back([]()
		{
			gchar *cdir = g_get_current_dir();
			gchar *path = g_build_filename(cdir, "test.pdf", NULL);
			gchar *uri = g_filename_to_uri(path, NULL, NULL);
			PopplerDocument *doc = poppler_document_new_from_file(uri, NULL, NULL);
			assert(doc);
			PopplerPage *page = poppler_document_get_page(doc, 0);

			cairo_surface_t *surface = cairo_image_surface_create(CAIRO_FORMAT_RGB24, 10, 10);
			cairo_t *ctx = cairo_create(surface);

			poppler_page_render(page, ctx);
		});
	for(auto &th : threads)th.join();
	return 0;
}
